import java.io.*;
import java.net.*;

public class WebSocketServer
{
  public static void main(String args[]) throws Exception
  {
    byte[] address = {127,0,0,2};
    ServerSocket ss = new ServerSocket(81, 0, InetAddress.getByAddress(address));

    Socket s = ss.accept();

    DataInputStream is = new DataInputStream(s.getInputStream());
    DataOutputStream os = new DataOutputStream(s.getOutputStream());

    try
    {
      byte[] last4chars = new byte[4];
      last4chars[0] = 0;last4chars[1] = 0;last4chars[2] = 0;last4chars[3] = 0;

      while (last4chars[0] != 0x0d || last4chars[1] != 0x0a ||
             last4chars[2] != 0x0d || last4chars[3] != 0x0a) {
        byte lido = is.readByte();
        last4chars[0] = last4chars[1];
        last4chars[1] = last4chars[2];
        last4chars[2] = last4chars[3];
        last4chars[3] = lido;
      }

      os.writeBytes("HTTP/1.1 101 Web Socket Protocol Handshake\r\n");
      os.writeBytes("Upgrade: WebSocket\r\n");
      os.writeBytes("Connection: Upgrade\r\n");
      os.writeBytes("websocket-origin: file://\r\n");
      os.writeBytes("websocket-location: ws://127.0.0.2/superXiao\r\n");
      os.writeBytes("\r\n");

      String pedido = "";
      while (true) {
        byte[] bytes = new byte[100];
        byte lido;
        int numBytes;

        lido = 0;
        numBytes = 0;

        while (lido != -1) {
          lido = is.readByte();
          if (lido != 0x00 && lido != -1) {
            if (numBytes == bytes.length) {
              System.out.println("error reading message");
              throw new Exception("fix me..");
            }
            bytes[numBytes++] = lido;
          }
        }

        pedido = new String(bytes, 0, numBytes, "UTF-8");
        if (pedido.compareTo("websocket session finished") == 0)
          break;

        Thread.sleep(1000);
        if (pedido.compareTo("websocket session started") == 0) {
          byte[] utf8 = "1".getBytes("UTF-8");
          os.writeByte(0x00);os.write(utf8, 0, utf8.length);os.writeByte(0xff);
        } else {
          byte[] utf8 = (""+((new Integer(pedido)).intValue()+1)).getBytes("UTF-8");
          os.writeByte(0x00);os.write(utf8, 0, utf8.length);os.writeByte(0xff);
        }
      }

    } catch (EOFException e) {
      ;
    }

    os.close();
    is.close();
    s.close();
    ss.close();
  }
}
